unit UnitMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, Menus, ImgList, ComCtrls, ToolWin, StdCtrls, Grids;

type
  TFormMain = class(TForm)
    Status: TStatusBar;
    ToolBar: TToolBar;
    tbDisp: TToolButton;
    ImageList: TImageList;
    MainMenu: TMainMenu;
    ActionList: TActionList;
    Open: TOpenDialog;
    Save: TSaveDialog;
    mFile: TMenuItem;
    mHelp: TMenuItem;
    ControlBox: TGroupBox;
    ObjectBox: TGroupBox;
    acNew: TAction;
    acOpen: TAction;
    acSave: TAction;
    tbNew: TToolButton;
    tbOpen: TToolButton;
    tbSave: TToolButton;
    mNew: TMenuItem;
    mOpen: TMenuItem;
    mSave: TMenuItem;
    mSep: TMenuItem;
    mExit: TMenuItem;
    mHelpAbout: TMenuItem;
    acWin: TAction;
    tbSpace: TToolButton;
    tbRunWin: TToolButton;
    SG: TStringGrid;
    acDos: TAction;
    tbRunDos: TToolButton;
    lCharNote: TLabel;
    lChar: TLabel;
    lDecNote: TLabel;
    lHexNote: TLabel;
    lDec: TLabel;
    lHex: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure acNewExecute(Sender: TObject);
    procedure acOpenExecute(Sender: TObject);
    procedure acSaveExecute(Sender: TObject);
    procedure mExitClick(Sender: TObject);
    procedure mHelpAboutClick(Sender: TObject);
    procedure acWinExecute(Sender: TObject);
    procedure SGDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect;
      State: TGridDrawState);
    procedure acDosExecute(Sender: TObject);
    procedure SGSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

implementation

uses UAbout, UCodeTable;

{$R *.dfm}

////////////////////////////////////////////////////////////////
//                                            //
////////////////////////////////////////////////////////////////

procedure TFormMain.FormActivate(Sender: TObject);  //  
begin
     //     
     Open.InitialDir:=ExtractFileDir(Application.ExeName);
     Save.InitialDir:=Open.InitialDir;
     CodeTable.Grid:=SG;
     acNewExecute(Sender);              // 
end;

procedure TFormMain.FormPaint(Sender: TObject);  //  
begin
     //      ""   
end;

procedure TFormMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     //        
end;


////////////////////////////////////////////////////////////////
//                                            //
////////////////////////////////////////////////////////////////

procedure TFormMain.acNewExecute(Sender: TObject);  // 
begin
     CodeTable.Clear;                   //   
     Status.Panels.Items[0].Text:='';   //   
     lChar.Caption:='';                 //    
     lDec.Caption:='';
     lHex.Caption:='';
end;

procedure TFormMain.acOpenExecute(Sender: TObject);  // 
var  F   :TextFile;  // 
     L,C :longint;   // 
     S   :string;    //   
begin
     if not Open.Execute then Exit;
     acNewExecute(Sender);                        // 
     Status.Panels.Items[0].Text:=Open.FileName;
     AssignFile(F,Open.FileName);
     Reset(F);
     for L:=3 to 16 do begin
         if not SeekEof(F) then Readln(F,S);
         for C:=1 to 16 do begin
             if C<=Length(S) then SG.Cells[C,L]:=S[C] else SG.Cells[C,L]:='';
         end;
     end;
     CloseFile(F);
end;

procedure TFormMain.acSaveExecute(Sender: TObject);  // 
var  F   :TextFile;  // 
     L,C :longint;   // 
     S   :string;    //   
begin
     if not Save.Execute then Exit;
     Status.Panels.Items[0].Text:=Save.FileName;
     AssignFile(F,Save.FileName);
     Rewrite(F);
     for L:=3 to 16 do begin
         S:='';
         for C:=1 to 16 do begin
             if SG.Cells[C,L]<>'' then S:=S+SG.Cells[C,L] else S:=S+' ';
         end;
         Writeln(F,S);
     end;
     CloseFile(F);
end;

procedure TFormMain.mExitClick(Sender: TObject);  // 
begin
     Close;
end;

procedure TFormMain.mHelpAboutClick(Sender: TObject);  //  
begin
     FormAbout.Left:=(FormMain.Width-FormAbout.Width) div 2;
     FormAbout.Top:=(FormMain.Height-FormAbout.Height) div 2;
     FormAbout.ShowModal;
end;

procedure TFormMain.acWinExecute(Sender: TObject);  //   Windows
begin
     CodeTable.RunWin;
     Status.Panels.Items[0].Text:='  Windows';
end;

procedure TFormMain.acDosExecute(Sender: TObject);  //   Dos
begin
     CodeTable.RunDos;
     Status.Panels.Items[0].Text:='  Dos';
end;


procedure TFormMain.SGDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);  //   
const  Dic  = '0123456789';                         // 
       Eng  = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';         //  
       Rus  = 'Ũ';  //  
       SRus = '';  //   
var  X,Y :longint;  //   ( )
     S   :char;     //  

   function Up(C:char):char;  // UpCase   
   var  P:longint;  // 
   begin
        P:=Pos(c,SRus);
        if P>0 then result:=Rus[P] else result:=UpCase(C);
   end;

begin
     //  
     SG.Canvas.Font.Color:=clBlack;
     if (ACol=0) or (ARow=0) then SG.Canvas.Brush.Color:=SG.FixedColor else begin
        SG.Canvas.Brush.Color:=clWhite;
        if SG.Cells[ACol,ARow]<>'' then begin
           //  
           S:=Up(SG.Cells[ACol,ARow][1]); 
           //   
           if Pos(S,'0123456789')>0     then SG.Canvas.Brush.Color:=clYellow;      // 
           if (ARow<8)and(Pos(S,Eng)>0) then SG.Canvas.Brush.Color:=clMoneyGreen;  // .
           if Pos(S,Rus)>0              then SG.Canvas.Brush.Color:=clSkyBlue;     // .
        end;
     end;
     SG.Canvas.FillRect(Rect);
     //    
     X:=Rect.Left+((Rect.Right-Rect.Left-SG.Canvas.TextWidth(SG.Cells[ACol,ARow])) div 2);
     Y:=Rect.Top+((Rect.Bottom-Rect.Top-SG.Canvas.TextHeight(SG.Cells[ACol,ARow])) div 2);
     SG.Canvas.TextOut(X,Y,SG.Cells[ACol,ARow]);
end;

procedure TFormMain.SGSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
var  B :byte;  //  
begin
     B:=(ARow-1)*16+(ACol-1);              //  
     lChar.Caption:=SG.Cells[ACol,ARow];   //  
     lDec.Caption:=IntToStr(B);            //  Dec 
     lHex.Caption:=CodeTable.DecToHex(B);  //  Hex 
end;

end.
